# 4 Point Cutting (WORK IN PROGRESS)
This set of scripts is an attempt to bring the famous 4 point editing features known from Magix' Sequoia to reaper.
## Requirements
This script does not work properly without SWS extensions (get them for free from http://standingwaterstudios.com/).
## Usage
### Basic functionality
* Set the beginning of the "source" region, from which the audio material will be copied by executing `4Pcut_set_SRC-IN`
* Set the end of the "source" region, from which the audio material will be copied by executing `4Pcut_set_SRC-OUT`
* Set the beginning of the "destination" region, to that the audio material will be copied by executing `4Pcut_set_DST-IN`
* Do the actual edit by executing `4Pcut_execute`
* Find the next source region you want to add and place source-in and source-out markers accordingly and run the execute script again. The destination marker(s) will be set automatically. 

### Edit modes
The script can be run with every combination of 3 markers. The two of them that specify a complete "region" (src-in and src-out or dst-in and dst-out) are used to determine the length of material to copy. The third marker only needs to specify one point of the other region, the length will be the same as the other region.
* `src-in`, `src-out`, `dst-in` set: Audio from the region between src-in and src-out will be copied after dst-in. dst-in will be moved to the right about the length of the copied material.
* `src-in`, `src-out`, `dst-out` set: Audio from the region between src-in and src-out will be copied before dst-out. dst-out will be set to the right about the length of the copied material
* `src-in`, `dst-in`, `dst-in` set: Audio from the src-in point with the length of the region between dst-in and dst-out will be copied after dst-in. dst-in and dst-out will be moved to the right about the length of the copied material.
* `src-out`, `dst-in`, `dst-out` set: Audio from the left of the src-out point with the length of the region between dst-in and dst-out will be copied after dst-in. dst-in and dst-out will be moved to the right about the length of the copied material.

If all 4 markers are set, the shorter region of the 2 specifies the length to be copied. The dst-in and dst-out markers will be moved to the right about the length of the copied material.

### Scripts
* `4Pcut_set_src-in`, `4Pcut_set_src-out`, `4Pcut_set_dst-in` and `4Pcut_set_dst_out` set markers with special names that are used to specify the source and destination regions to be edited.
* `4Pcut_reset_markers` deletes all four of the special markers, if present.
* `4Pcut_execute` executes one edit, copies the audio material from source to destination and sets the destination markers accordingly for the next edit step.
* `4Pcut_set_src-tracks` sets the currently selected tracks as the source tracks from which audio material will be copied. If unset, all tracks will be used.
* `4Pcut_set_dst-track` sets the first of the currently selected tracks as the first destination track to which audio material will be copied. If unset, track one will be used.
* `4Pcut_select_src-tracks` selects the stored source tracks set by `4Pcut_set_src-tracks`.
* `4Pcut_select_dst-track` selects the stored destination track set by `4Pcut_set_dst-track`.
* `4Pcut_reset_src-dst-tracks` resets the source tracks to "all" and the destination track to track one.

## Screenshots
Markers set:
![](https://files.eleton-audio.de/gitea/Ludwig/Reaper-Scripts/raw/branch/4PointCutting/4PointCutting/screenshots/3markers.PNG)
After execution:
![](https://files.eleton-audio.de/gitea/Ludwig/Reaper-Scripts/raw/branch/4PointCutting/4PointCutting/screenshots/3markers_1edit.PNG)